scala.collection

# GenTraversableOnce

#### trait GenTraversableOnce[+A] extends AnyRef

A template trait for all traversable-once objects which may be traversed in parallel.

Methods in this trait are either abstract or can be implemented in terms of other methods.

Source
  GenTraversableOnce.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
::, AbsScope, Appended, Appended, Appended, Appended, Appended, Appended, Appended, Appended, Appended, Appended, Appended, ArrayBuffer, ArrayLike, ArrayOps, ArraySeq, ArrayStack, Atom, Attribute, BitSet, BitSet, BitSet, BitSet1, BitSet2, BitSetLike, BitSetN, Buffer, BufferLike, BufferProxy, BufferWrapper, BufferedIterator, BufferedLineIterator, BufferedSource, ByOne, Comment, ConcurrentMap, Cons, Content, CountedIterator, DefaultKeySet, DefaultKeySortedSet, DefaultKeySortedSet, DefaultMap, DefaultMap, DefaultMapModel, DefaultValuesIterable, Document, DoubleLinkedList, DoubleLinkedListLike, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, DroppedWhile, Elem, Elements, Elements, Empty, EmptyMap, EmptyMap, EmptySet, EmptySet, EmptyView, EmptyView, EmptyView, EmptyView, EmptyView, EmptyView, EmptyView, EntityRef, EntryIterator, Exclusive, Filtered, Filtered, Filtered, Filtered, Filtered, Filtered, Filtered, Filtered, FlatMapped, FlatMapped, FlatMapped, FlatMapped, FlatMapped, FlatMapped, FlatMapped, Forced, Forced, Forced, Forced, Forced, Forced, Forced, Forced, Forced, GenIterable, GenIterableLike, GenIterableView, GenIterableViewLike, GenMap, GenMapLike, GenSeq, GenSeqLike, GenSeqView, GenSeqViewLike, GenSet, GenSetLike, GenTraversable, GenTraversableLike, GenTraversableView, GenTraversableViewLike, Group, GroupedIterator, HashMap, HashMap, HashMap1, HashSet, HashSet, HashSet1, HashTrieMap, HashTrieSet, History, ImmutableDefaultKeySet, ImmutableMapAdaptor, ImmutableSetAdaptor, Impl, Inclusive, Inclusive, IndexedSeq, IndexedSeq, IndexedSeq, IndexedSeqLike, IndexedSeqLike, IndexedSeqOptimized, IndexedSeqOptimized, IndexedSeqView, Indices, IntMap, Iterable, Iterable, Iterable, IterableForwarder, IterableLike, IterableProxy, IterableProxyLike, IterableSplitter, IterableView, IterableViewLike, Iterator, JCollectionWrapper, JConcurrentMapWrapper, JDictionaryWrapper, JEnumerationWrapper, JIterableWrapper, JIteratorWrapper, JListWrapper, JMapWrapper, JMapWrapperLike, JPropertiesWrapper, JSetWrapper, LineIterator, LinearSeq, LinearSeq, LinearSeq, LinearSeqLike, LinearSeqOptimized, LinkedHashMap, LinkedHashSet, LinkedList, LinkedListLike, List, ListBuffer, ListMap, ListMap, ListSet, LongMap, Map, Map, Map, Map1, Map2, Map3, Map4, MapLike, MapLike, MapLike, MapProxy, MapProxy, MapProxy, MapProxyLike, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, Mapped, MatchIterator, MetaData, MultiMap, MutableList, Nil, Node, Node, Node, NodeBuffer, NodeSeq, Null, NumericRange, ObservableBuffer, ObservableMap, ObservableSet, OpenHashMap, PCData, PagedSeq, ParArray, ParArrayIterator, ParFlatHashTableIterator, ParHashMap, ParHashMap, ParHashMapIterator, ParHashMapIterator, ParHashSet, ParHashSet, ParHashSetIterator, ParHashSetIterator, ParIterable, ParIterable, ParIterable, ParIterableLike, ParIterableView, ParIterableViewLike, ParIterator, ParIterator, ParMap, ParMap, ParMap, ParMapLike, ParMapLike, ParRange, ParRangeIterator, ParSeq, ParSeq, ParSeq, ParSeqLike, ParSeqView, ParSeqViewLike, ParSet, ParSet, ParSet, ParSetLike, ParSetLike, ParVector, ParVectorIterator, Patched, Patched, Patched, Patched, Patched, PicklerEnv, PreciseSplitter, PrefixedAttribute, Prepended, Prepended, Prepended, Prepended, PriorityQueue, PriorityQueueProxy, ProcInstr, ProducerConsumerIterator, Queue, Queue, QueueProxy, Range, RefBuffer, ResizableArray, Reversed, Reversed, Reversed, Reversed, Reversed, RevertibleHistory, Scope, Script, SelectionSet, Seq, Seq, Seq, SeqForwarder, SeqLike, SeqLike, SeqProxy, SeqProxyLike, SeqSplitter, SeqView, SeqViewLike, Set, Set, Set, Set1, Set2, Set3, Set4, SetLike, SetLike, SetProxy, SetProxy, SetProxy, SetProxyLike, SignalContextPassingIterator, SignalContextPassingIterator, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, Sliced, SortedMap, SortedMap, SortedMapLike, SortedSet, SortedSet, SortedSetLike, Source, SpecialNode, Splitter, Stack, Stack, StackProxy, Stream, StreamIterator, StreamView, StreamViewLike, StringBuilder, StringLike, StringOps, SynchronizedBuffer, SynchronizedMap, SynchronizedPriorityQueue, SynchronizedQueue, SynchronizedSet, SynchronizedStack, SystemProperties, Taken, Taken, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, TakenWhile, Text, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Transformed, Traversable, Traversable, Traversable, TraversableForwarder, TraversableLike, TraversableOnce, TraversableProxy, TraversableProxyLike, TraversableView, TraversableViewLike, TreeMap, TreeSet, UnPicklerEnv, Unparsed, UnprefixedAttribute, UnrolledBuffer, ValueSet, Vector, VectorIterator, WeakHashMap, WithDefault, WithDefault, WithDefault, WrappedArray, WrappedString, XMLEventReader, Zipped, Zipped, Zipped, Zipped, Zipped, Zipped, Zipped, Zipped, Zipped, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, ZippedAll, columns, indices, ofBoolean, ofBoolean, ofByte, ofByte, ofChar, ofChar, ofDouble, ofDouble, ofFloat, ofFloat, ofInt, ofInt, ofLong, ofLong, ofRef, ofRef, ofShort, ofShort, ofUnit, ofUnit, pages, rows
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. GenTraversableOnce
2. AnyRef
3. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def /:[B](z: B)(op: (B, A) ⇒ B): B

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   B

     the result type of the binary operator.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this collection or iterator.

2. #### abstract def :\[B](z: B)(op: (A, B) ⇒ B): B

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

   Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a :\ 5)(_+_)
            b: Int = 15

            scala> val c = (a :\ 5)((x,y) => x + y)
            c: Int = 15

   B

     the result type of the binary operator.

   z

     the start value

   op

     the binary operator

   returns

     the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

                     op(x1, op(x2, ... op(xn, z)...))

     where `x1, ..., xn` are the elements of this collection or iterator.

3. #### abstract def aggregate[B](z: B)(seqop: (B, A) ⇒ B, combop: (B, B) ⇒ B): B

   Aggregates the results of applying an operator to subsequent elements.

   Aggregates the results of applying an operator to subsequent elements.

   This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

   For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

          pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

   Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

   B

     the type of accumulated results

   z

     the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

   seqop

     an operator used to accumulate results within a partition

   combop

     an associative operator used to combine results from different partitions

4. #### abstract def copyToArray[B >: A](xs: Array[B], start: Int, len: Int): Unit

5. #### abstract def copyToArray[B >: A](xs: Array[B], start: Int): Unit

   Copies values of this collection or iterator to an array.

   Copies values of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator, beginning at index `start`. Copying will stop once either the end of the current collection or iterator is reached, or the end of the array is reached.

   Note: will not terminate for infinite-sized collections.

   B

     the type of the elements of the array.

   xs

     the array to fill.

   start

     the starting index.

6. #### abstract def copyToArray[B >: A](xs: Array[B]): Unit

   Copies values of this collection or iterator to an array.

   Copies values of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator. Copying will stop once either the end of the current collection or iterator is reached, or the end of the array is reached.

   Note: will not terminate for infinite-sized collections.

   B

     the type of the elements of the array.

   xs

     the array to fill.

7. #### abstract def count(p: (A) ⇒ Boolean): Int

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   Counts the number of elements in the collection or iterator which satisfy a predicate.

   p

     the predicate used to test elements.

   returns

     the number of elements satisfying the predicate `p`.

8. #### abstract def exists(pred: (A) ⇒ Boolean): Boolean

9. #### abstract def find(pred: (A) ⇒ Boolean): Option[A]

   Finds the first element of the collection or iterator satisfying a predicate, if any.

   Finds the first element of the collection or iterator satisfying a predicate, if any.

   Note: may not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered.

   returns

     an option value containing the first element in the collection or iterator that satisfies `p`, or `None` if none exists.

10. #### abstract def fold[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this collection or iterator using the specified associative binary operator.

    Folds the elements of this collection or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

11. #### abstract def foldLeft[B](z: B)(op: (B, A) ⇒ B): B

    Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this collection or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this collection or iterator.

12. #### abstract def foldRight[B](z: B)(op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this collection or iterator and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

13. #### abstract def forall(pred: (A) ⇒ Boolean): Boolean

14. #### abstract def foreach[U](f: (A) ⇒ U): Unit

15. #### abstract def hasDefiniteSize: Boolean

16. #### abstract def isEmpty: Boolean

    Tests whether the collection or iterator is empty.

    Tests whether the collection or iterator is empty.

    returns

      `true` if the collection or iterator contains no elements, `false` otherwise.

17. #### abstract def isTraversableAgain: Boolean

    Tests whether this collection or iterator can be repeatedly traversed.

    Tests whether this collection or iterator can be repeatedly traversed. Always true for Traversables and false for Iterators unless overridden.

    returns

      `true` if it is repeatedly traversable, `false` otherwise.

18. #### abstract def max[A1 >: A](implicit ord: Ordering[A1]): A

    Finds the largest element.

    Finds the largest element.

    returns

      the largest element of this collection or iterator with respect to the ordering `cmp`.

19. #### abstract def maxBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

20. #### abstract def min[A1 >: A](implicit ord: Ordering[A1]): A

    Finds the smallest element.

    Finds the smallest element.

    returns

      the smallest element of this collection or iterator with respect to the ordering `cmp`.

21. #### abstract def minBy[B](f: (A) ⇒ B)(implicit cmp: Ordering[B]): A

22. #### abstract def mkString: String

    Displays all elements of this collection or iterator in a string.

    Displays all elements of this collection or iterator in a string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator follow each other without any separator string.

23. #### abstract def mkString(sep: String): String

    Displays all elements of this collection or iterator in a string using a separator string.

    Displays all elements of this collection or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this collection or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

24. #### abstract def mkString(start: String, sep: String, end: String): String

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    Displays all elements of this collection or iterator in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this collection or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this collection or iterator are separated by the string `sep`.

    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

25. #### abstract def nonEmpty: Boolean

    Tests whether the collection or iterator is not empty.

    Tests whether the collection or iterator is not empty.

    returns

      `true` if the collection or iterator contains at least one element, `false` otherwise.

26. #### abstract def product[A1 >: A](implicit num: Numeric[A1]): A1

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this collection or iterator with respect to the `*` operator in `num`.

27. #### abstract def reduce[A1 >: A](op: (A1, A1) ⇒ A1): A1

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    Reduces the elements of this collection or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection or iterator is nonempty.

    Exceptions thrown
      UnsupportedOperationException

      if this collection or iterator is empty.

28. #### abstract def reduceLeftOption[B >: A](op: (B, A) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Optionally applies a binary operator to all elements of this collection or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this collection or iterator is nonempty, `None` otherwise.

29. #### abstract def reduceOption[A1 >: A](op: (A1, A1) ⇒ A1): Option[A1]

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    Reduces the elements of this collection or iterator, if any, using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      A type parameter for the binary operator, a supertype of `A`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

30. #### abstract def reduceRight[B >: A](op: (A, B) ⇒ B): B

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this collection or iterator, going right to left:

                      op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

      where `x1, ..., xn` are the elements of this collection or iterator.

    Exceptions thrown
      `UnsupportedOperationException`

      if this collection or iterator is empty.

31. #### abstract def reduceRightOption[B >: A](op: (A, B) ⇒ B): Option[B]

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Optionally applies a binary operator to all elements of this collection or iterator, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this collection or iterator is nonempty, `None` otherwise.

32. #### abstract def seq: TraversableOnce[A]

33. #### abstract def size: Int

    The size of this collection or iterator.

    The size of this collection or iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      the number of elements in this collection or iterator.

34. #### abstract def sum[A1 >: A](implicit num: Numeric[A1]): A1

    Sums up the elements of this collection.

    Sums up the elements of this collection.

    num

      an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

    returns

      the sum of all elements of this collection or iterator with respect to the `+` operator in `num`.

35. #### abstract def toArray[A1 >: A](implicit arg0: ClassManifest[A1]): Array[A1]

    Converts this collection or iterator to an array.

    Converts this collection or iterator to an array.

    Note: will not terminate for infinite-sized collections.

    returns

      an array containing all elements of this collection or iterator.

36. #### abstract def toBuffer[A1 >: A]: Buffer[A1]

    Converts this collection or iterator to a mutable buffer.

    Converts this collection or iterator to a mutable buffer.

    Note: will not terminate for infinite-sized collections.

    returns

      a buffer containing all elements of this collection or iterator.

37. #### abstract def toIndexedSeq[A1 >: A]: IndexedSeq[A1]

    Converts this collection or iterator to an indexed sequence.

    Converts this collection or iterator to an indexed sequence.

    Note: will not terminate for infinite-sized collections.

    returns

      an indexed sequence containing all elements of this collection or iterator.

38. #### abstract def toIterable: GenIterable[A]

    Converts this collection or iterator to an iterable collection.

    Converts this collection or iterator to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

    Note: will not terminate for infinite-sized collections.

    returns

      an `Iterable` containing all elements of this collection or iterator.

39. #### abstract def toIterator: Iterator[A]

    Returns an Iterator over the elements in this collection or iterator.

    Returns an Iterator over the elements in this collection or iterator. Will return the same Iterator if this instance is already an Iterator.

    Note: will not terminate for infinite-sized collections.

    returns

      an Iterator containing all elements of this collection or iterator.

40. #### abstract def toList: List[A]

    Converts this collection or iterator to a list.

    Converts this collection or iterator to a list.

    Note: will not terminate for infinite-sized collections.

    returns

      a list containing all elements of this collection or iterator.

41. #### abstract def toMap[K, V](implicit ev: <:<[A, (K, V)]): GenMap[K, V]

    Converts this collection or iterator to a map.

    Converts this collection or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map containing all elements of this collection or iterator.

42. #### abstract def toSeq: GenSeq[A]

    Converts this collection or iterator to a sequence.

    Converts this collection or iterator to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

    Note: will not terminate for infinite-sized collections.

    returns

      a sequence containing all elements of this collection or iterator.

43. #### abstract def toSet[A1 >: A]: GenSet[A1]

    Converts this collection or iterator to a set.

    Converts this collection or iterator to a set.

    Note: will not terminate for infinite-sized collections.

    returns

      a set containing all elements of this collection or iterator.

44. #### abstract def toStream: Stream[A]

    Converts this collection or iterator to a stream.

    Converts this collection or iterator to a stream.

    Note: will not terminate for infinite-sized collections.

    returns

      a stream containing all elements of this collection or iterator.

45. #### abstract def toTraversable: GenTraversable[A]

    Converts this collection or iterator to an unspecified Traversable.

    Converts this collection or iterator to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

    Note: will not terminate for infinite-sized collections.

    returns

      a Traversable containing all elements of this collection or iterator.

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def /:\[A1 >: A](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a /:\ 5)(_+_)
            b: Int = 15

5. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

6. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

9. #### abstract def copyToArray(xs: Array[A], start: Int): Unit

   [use case] Copies values of this collection or iterator to an array.

   [use case]

   Copies values of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator, beginning at index `start`. Copying will stop once either the end of the current collection or iterator is reached, or the end of the array is reached.

   xs

     the array to fill.

   start

     the starting index.

10. #### abstract def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this collection or iterator to an array.

    [use case]

    Copies values of this collection or iterator to an array. Fills the given array `xs` with values of this collection or iterator. Copying will stop once either the end of the current collection or iterator is reached, or the end of the array is reached.

    xs

      the array to fill.

11. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

12. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

13. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

14. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

15. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

16. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

17. #### abstract def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this collection or iterator with respect to the ordering `cmp`.

18. #### abstract def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this collection or iterator with respect to the ordering `cmp`.

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### abstract def product: A

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements of this collection or iterator with respect to the `*` operator in `num`.

23. #### abstract def sum: A

    [use case] Sums up the elements of this collection.

    [use case]

    Sums up the elements of this collection.

    returns

      the sum of all elements of this collection or iterator with respect to the `+` operator in `num`.

24. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

25. #### abstract def toArray: Array[A]

    [use case] Converts this collection or iterator to an array.

    [use case]

    Converts this collection or iterator to an array.

    Note: will not terminate for infinite-sized collections.

    returns

      an array containing all elements of this collection or iterator.

26. #### abstract def toMap[T, U]: Map[T, U]

    [use case] Converts this collection or iterator to a map.

    [use case]

    Converts this collection or iterator to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

    Note: will not terminate for infinite-sized collections.

    returns

      a map containing all elements of this collection or iterator.

27. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

28. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

29. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

30. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from AnyRef

### Inherited from Any